Index: src/backend/access/heap/heapam.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/access/heap/heapam.c,v
retrieving revision 1.187
diff -c -r1.187 heapam.c
*** src/backend/access/heap/heapam.c	14 Apr 2005 20:03:22 -0000	1.187
--- src/backend/access/heap/heapam.c	18 Apr 2005 22:01:48 -0000
***************
*** 40,45 ****
--- 40,46 ----
  
  #include "access/heapam.h"
  #include "access/hio.h"
+ #include "access/multixact.h"
  #include "access/tuptoaster.h"
  #include "access/valid.h"
  #include "access/xlogutils.h"
***************
*** 1240,1248 ****
  	{
  		TransactionId xwait = HeapTupleHeaderGetXmax(tp.t_data);
  
! 		/* sleep until concurrent transaction ends */
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
! 		XactLockTableWait(xwait);
  
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  		if (!TransactionIdDidCommit(xwait))
--- 1241,1257 ----
  	{
  		TransactionId xwait = HeapTupleHeaderGetXmax(tp.t_data);
  
! 		/*
! 		 * Sleep until concurrent transaction ends.  Note that we don't care
! 		 * if the locker has an exclusive or shared lock, because ours is
! 		 * exclusive.
! 		 */
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
! 
! 		if (tp.t_data->t_infomask & HEAP_XMAX_SHARED_LOCK)
! 			MultiXactIdWait(xwait);
! 		else
! 			XactLockTableWait(xwait);
  
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  		if (!TransactionIdDidCommit(xwait))
***************
*** 1260,1267 ****
  			tp.t_data->t_infomask |= HEAP_XMAX_COMMITTED;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
! 		/* if tuple was marked for update but not updated... */
! 		if (tp.t_data->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
--- 1269,1276 ----
  			tp.t_data->t_infomask |= HEAP_XMAX_COMMITTED;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
! 		/* if tuple was locked but not updated... */
! 		if (tp.t_data->t_infomask & HEAP_LOCKED)
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
***************
*** 1290,1296 ****
  	/* store transaction information of xact deleting the tuple */
  	tp.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  							   HEAP_XMAX_INVALID |
! 							   HEAP_MARKED_FOR_UPDATE |
  							   HEAP_MOVED);
  	HeapTupleHeaderSetXmax(tp.t_data, xid);
  	HeapTupleHeaderSetCmax(tp.t_data, cid);
--- 1299,1305 ----
  	/* store transaction information of xact deleting the tuple */
  	tp.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  							   HEAP_XMAX_INVALID |
! 							   HEAP_LOCKED |
  							   HEAP_MOVED);
  	HeapTupleHeaderSetXmax(tp.t_data, xid);
  	HeapTupleHeaderSetCmax(tp.t_data, cid);
***************
*** 1469,1475 ****
  
  		/* sleep until concurrent transaction ends */
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
! 		XactLockTableWait(xwait);
  
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  		if (!TransactionIdDidCommit(xwait))
--- 1478,1487 ----
  
  		/* sleep until concurrent transaction ends */
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
! 		if (oldtup.t_data->t_infomask & HEAP_XMAX_SHARED_LOCK)
! 			MultiXactIdWait(xwait);
! 		else
! 			XactLockTableWait(xwait);
  
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  		if (!TransactionIdDidCommit(xwait))
***************
*** 1487,1494 ****
  			oldtup.t_data->t_infomask |= HEAP_XMAX_COMMITTED;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
! 		/* if tuple was marked for update but not updated... */
! 		if (oldtup.t_data->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
--- 1499,1506 ----
  			oldtup.t_data->t_infomask |= HEAP_XMAX_COMMITTED;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
! 		/* if tuple was locked but not updated... */
! 		if (oldtup.t_data->t_infomask & HEAP_LOCKED)
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
***************
*** 1556,1562 ****
  	{
  		oldtup.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  									   HEAP_XMAX_INVALID |
! 									   HEAP_MARKED_FOR_UPDATE |
  									   HEAP_MOVED);
  		HeapTupleHeaderSetXmax(oldtup.t_data, xid);
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid);
--- 1568,1574 ----
  	{
  		oldtup.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  									   HEAP_XMAX_INVALID |
! 									   HEAP_LOCKED |
  									   HEAP_MOVED);
  		HeapTupleHeaderSetXmax(oldtup.t_data, xid);
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid);
***************
*** 1642,1648 ****
  	{
  		oldtup.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  									   HEAP_XMAX_INVALID |
! 									   HEAP_MARKED_FOR_UPDATE |
  									   HEAP_MOVED);
  		HeapTupleHeaderSetXmax(oldtup.t_data, xid);
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid);
--- 1654,1660 ----
  	{
  		oldtup.t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  									   HEAP_XMAX_INVALID |
! 									   HEAP_LOCKED |
  									   HEAP_MOVED);
  		HeapTupleHeaderSetXmax(oldtup.t_data, xid);
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid);
***************
*** 1739,1755 ****
  }
  
  /*
!  *	heap_mark4update		- mark a tuple for update
   */
  HTSU_Result
! heap_mark4update(Relation relation, HeapTuple tuple, Buffer *buffer,
! 				 CommandId cid)
  {
! 	TransactionId xid = GetCurrentTransactionId();
  	ItemPointer tid = &(tuple->t_self);
  	ItemId		lp;
  	PageHeader	dp;
  	HTSU_Result	result;
  
  	*buffer = ReadBuffer(relation, ItemPointerGetBlockNumber(tid));
  	LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
--- 1751,1768 ----
  }
  
  /*
!  *	heap_lock_tuple		- lock a tuple in shared or exclusive mode
   */
  HTSU_Result
! heap_lock_tuple(Relation relation, HeapTuple tuple, Buffer *buffer,
! 				 CommandId cid, LockTupleMode mode)
  {
! 	TransactionId	xid;
  	ItemPointer tid = &(tuple->t_self);
  	ItemId		lp;
  	PageHeader	dp;
  	HTSU_Result	result;
+ 	MultiXactId	lockers = InvalidMultiXactId;
  
  	*buffer = ReadBuffer(relation, ItemPointerGetBlockNumber(tid));
  	LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
***************
*** 1767,1803 ****
  	{
  		LockBuffer(*buffer, BUFFER_LOCK_UNLOCK);
  		ReleaseBuffer(*buffer);
! 		elog(ERROR, "attempted to mark4update invisible tuple");
  	}
  	else if (result == HeapTupleBeingUpdated)
  	{
! 		TransactionId xwait = HeapTupleHeaderGetXmax(tuple->t_data);
  
! 		/* sleep until concurrent transaction ends */
! 		LockBuffer(*buffer, BUFFER_LOCK_UNLOCK);
! 		XactLockTableWait(xwait);
  
! 		LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
! 		if (!TransactionIdDidCommit(xwait))
! 			goto l3;
  
! 		/*
! 		 * xwait is committed but if xwait had just marked the tuple for
! 		 * update then some other xaction could update this tuple before
! 		 * we got to this point.
! 		 */
! 		if (!TransactionIdEquals(HeapTupleHeaderGetXmax(tuple->t_data), xwait))
! 			goto l3;
! 		if (!(tuple->t_data->t_infomask & HEAP_XMAX_COMMITTED))
! 		{
! 			tuple->t_data->t_infomask |= HEAP_XMAX_COMMITTED;
! 			SetBufferCommitInfoNeedsSave(*buffer);
  		}
- 		/* if tuple was marked for update but not updated... */
- 		if (tuple->t_data->t_infomask & HEAP_MARKED_FOR_UPDATE)
- 			result = HeapTupleMayBeUpdated;
- 		else
- 			result = HeapTupleUpdated;
  	}
  	if (result != HeapTupleMayBeUpdated)
  	{
--- 1780,1828 ----
  	{
  		LockBuffer(*buffer, BUFFER_LOCK_UNLOCK);
  		ReleaseBuffer(*buffer);
! 		elog(ERROR, "attempted to lock invisible tuple");
  	}
  	else if (result == HeapTupleBeingUpdated)
  	{
! 		if (mode == LockTupleShared &&
! 			(tuple->t_data->t_infomask & HEAP_XMAX_SHARED_LOCK))
! 		{
! 			lockers = HeapTupleHeaderGetXmax(tuple->t_data);
! 			result = HeapTupleMayBeUpdated;
! 		}
! 		else
! 		{
! 			TransactionId xwait = HeapTupleHeaderGetXmax(tuple->t_data);
  
! 			/* sleep until concurrent transaction ends */
! 			LockBuffer(*buffer, BUFFER_LOCK_UNLOCK);
! 			if (tuple->t_data->t_infomask & HEAP_XMAX_SHARED_LOCK)
! 				MultiXactIdWait(xwait);
! 			else
! 				XactLockTableWait(xwait);
  
! 			LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
! 			if (!TransactionIdDidCommit(xwait))
! 				goto l3;
  
! 			/*
! 			 * xwait is committed but if xwait had just marked the tuple for
! 			 * update then some other xaction could update this tuple before
! 			 * we got to this point.
! 			 */
! 			if (!TransactionIdEquals(HeapTupleHeaderGetXmax(tuple->t_data), xwait))
! 				goto l3;
! 			if (!(tuple->t_data->t_infomask & HEAP_XMAX_COMMITTED))
! 			{
! 				tuple->t_data->t_infomask |= HEAP_XMAX_COMMITTED;
! 				SetBufferCommitInfoNeedsSave(*buffer);
! 			}
! 			/* if tuple was marked for update but not updated... */
! 			if (tuple->t_data->t_infomask & HEAP_LOCKED)
! 				result = HeapTupleMayBeUpdated;
! 			else
! 				result = HeapTupleUpdated;
  		}
  	}
  	if (result != HeapTupleMayBeUpdated)
  	{
***************
*** 1808,1824 ****
  	}
  
  	/*
! 	 * XLOG stuff: no logging is required as long as we have no
! 	 * savepoints. For savepoints private log could be used...
  	 */
  	PageSetTLI(BufferGetPage(*buffer), ThisTimeLineID);
  
  	/* store transaction information of xact marking the tuple */
  	tuple->t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  								   HEAP_XMAX_INVALID |
  								   HEAP_MOVED);
! 	tuple->t_data->t_infomask |= HEAP_MARKED_FOR_UPDATE;
! 	HeapTupleHeaderSetXmax(tuple->t_data, xid);
  	HeapTupleHeaderSetCmax(tuple->t_data, cid);
  	/* Make sure there is no forward chain link in t_ctid */
  	tuple->t_data->t_ctid = *tid;
--- 1833,1863 ----
  	}
  
  	/*
! 	 * XLOG stuff: no logging is required as long as we don't have
! 	 * two-phase commit.
  	 */
  	PageSetTLI(BufferGetPage(*buffer), ThisTimeLineID);
+ 	xid = GetCurrentTransactionId();
  
  	/* store transaction information of xact marking the tuple */
  	tuple->t_data->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  								   HEAP_XMAX_INVALID |
+ 								   HEAP_LOCKED |
  								   HEAP_MOVED);
! 
! 
! 	if (mode == LockTupleShared)
! 	{
! 		lockers = MultiXactIdExpand(lockers, xid);
! 
! 		tuple->t_data->t_infomask |= HEAP_XMAX_SHARED_LOCK;
! 		HeapTupleHeaderSetXmax(tuple->t_data, lockers);
! 	}
! 	else
! 	{
! 		tuple->t_data->t_infomask |= HEAP_XMAX_EXCLUSIVE_LOCK;
! 		HeapTupleHeaderSetXmax(tuple->t_data, xid);
! 	}
  	HeapTupleHeaderSetCmax(tuple->t_data, cid);
  	/* Make sure there is no forward chain link in t_ctid */
  	tuple->t_data->t_ctid = *tid;
***************
*** 1997,2003 ****
  		TransactionId xid[2];	/* xmax, xmin */
  
  		if (newtup->t_data->t_infomask & (HEAP_XMAX_INVALID |
! 										  HEAP_MARKED_FOR_UPDATE))
  			xid[0] = InvalidTransactionId;
  		else
  			xid[0] = HeapTupleHeaderGetXmax(newtup->t_data);
--- 2036,2042 ----
  		TransactionId xid[2];	/* xmax, xmin */
  
  		if (newtup->t_data->t_infomask & (HEAP_XMAX_INVALID |
! 										  HEAP_LOCKED))
  			xid[0] = InvalidTransactionId;
  		else
  			xid[0] = HeapTupleHeaderGetXmax(newtup->t_data);
***************
*** 2185,2191 ****
  	{
  		htup->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  							  HEAP_XMAX_INVALID |
! 							  HEAP_MARKED_FOR_UPDATE |
  							  HEAP_MOVED);
  		HeapTupleHeaderSetXmax(htup, record->xl_xid);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId);
--- 2224,2230 ----
  	{
  		htup->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  							  HEAP_XMAX_INVALID |
! 							  HEAP_LOCKED |
  							  HEAP_MOVED);
  		HeapTupleHeaderSetXmax(htup, record->xl_xid);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId);
***************
*** 2365,2371 ****
  		{
  			htup->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  								  HEAP_XMAX_INVALID |
! 								  HEAP_MARKED_FOR_UPDATE |
  								  HEAP_MOVED);
  			HeapTupleHeaderSetXmax(htup, record->xl_xid);
  			HeapTupleHeaderSetCmax(htup, FirstCommandId);
--- 2404,2410 ----
  		{
  			htup->t_infomask &= ~(HEAP_XMAX_COMMITTED |
  								  HEAP_XMAX_INVALID |
! 								  HEAP_LOCKED |
  								  HEAP_MOVED);
  			HeapTupleHeaderSetXmax(htup, record->xl_xid);
  			HeapTupleHeaderSetCmax(htup, FirstCommandId);
Index: src/backend/access/transam/Makefile
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/access/transam/Makefile,v
retrieving revision 1.19
diff -c -r1.19 Makefile
*** src/backend/access/transam/Makefile	1 Jul 2004 00:49:42 -0000	1.19
--- src/backend/access/transam/Makefile	16 Apr 2005 18:20:47 -0000
***************
*** 12,18 ****
  top_builddir = ../../../..
  include $(top_builddir)/src/Makefile.global
  
! OBJS = clog.o transam.o varsup.o xact.o xlog.o xlogutils.o rmgr.o slru.o subtrans.o
  
  all: SUBSYS.o
  
--- 12,18 ----
  top_builddir = ../../../..
  include $(top_builddir)/src/Makefile.global
  
! OBJS = clog.o transam.o varsup.o xact.o xlog.o xlogutils.o rmgr.o slru.o subtrans.o multixact.o
  
  all: SUBSYS.o
  
Index: src/backend/access/transam/varsup.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/access/transam/varsup.c,v
retrieving revision 1.63
diff -c -r1.63 varsup.c
*** src/backend/access/transam/varsup.c	13 Apr 2005 18:54:56 -0000	1.63
--- src/backend/access/transam/varsup.c	18 Apr 2005 22:01:49 -0000
***************
*** 14,19 ****
--- 14,20 ----
  #include "postgres.h"
  
  #include "access/clog.h"
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/transam.h"
  #include "miscadmin.h"
***************
*** 148,153 ****
--- 149,156 ----
  			else
  				MyProc->subxids.overflowed = true;
  		}
+ 
+ 		MyProc->mxmin = InvalidMultiXactId;
  	}
  
  	LWLockRelease(XidGenLock);
Index: src/backend/access/transam/xact.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/access/transam/xact.c,v
retrieving revision 1.199
diff -c -r1.199 xact.c
*** src/backend/access/transam/xact.c	11 Apr 2005 19:51:14 -0000	1.199
--- src/backend/access/transam/xact.c	18 Apr 2005 22:01:49 -0000
***************
*** 20,25 ****
--- 20,26 ----
  #include <time.h>
  #include <unistd.h>
  
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/xact.h"
  #include "catalog/heap.h"
***************
*** 1537,1542 ****
--- 1538,1544 ----
  	 * by the ResourceOwner mechanism.	The other calls here are for
  	 * backend-wide state.
  	 */
+ 	AtEOXact_MultiXact();
  
  	CallXactCallbacks(XACT_EVENT_COMMIT);
  
***************
*** 1701,1706 ****
--- 1703,1709 ----
  	 * Post-abort cleanup.	See notes in CommitTransaction() concerning
  	 * ordering.
  	 */
+ 	AtEOXact_MultiXact();
  
  	CallXactCallbacks(XACT_EVENT_ABORT);
  
***************
*** 3622,3630 ****
  ShowTransactionState(const char *str)
  {
  	/* skip work if message will definitely not be printed */
! 	if (log_min_messages <= DEBUG2 || client_min_messages <= DEBUG2)
  	{
! 		elog(DEBUG2, "%s", str);
  		ShowTransactionStateRec(CurrentTransactionState);
  	}
  }
--- 3625,3633 ----
  ShowTransactionState(const char *str)
  {
  	/* skip work if message will definitely not be printed */
! 	if (log_min_messages <= DEBUG3 || client_min_messages <= DEBUG3)
  	{
! 		elog(DEBUG3, "%s", str);
  		ShowTransactionStateRec(CurrentTransactionState);
  	}
  }
***************
*** 3640,3646 ****
  		ShowTransactionStateRec(s->parent);
  
  	/* use ereport to suppress computation if msg will not be printed */
! 	ereport(DEBUG2,
  			(errmsg_internal("name: %s; blockState: %13s; state: %7s, xid/subid/cid: %u/%u/%u, nestlvl: %d, children: %s",
  						   PointerIsValid(s->name) ? s->name : "unnamed",
  							 BlockStateAsString(s->blockState),
--- 3643,3649 ----
  		ShowTransactionStateRec(s->parent);
  
  	/* use ereport to suppress computation if msg will not be printed */
! 	ereport(DEBUG3,
  			(errmsg_internal("name: %s; blockState: %13s; state: %7s, xid/subid/cid: %u/%u/%u, nestlvl: %d, children: %s",
  						   PointerIsValid(s->name) ? s->name : "unnamed",
  							 BlockStateAsString(s->blockState),
Index: src/backend/access/transam/xlog.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/access/transam/xlog.c,v
retrieving revision 1.187
diff -c -r1.187 xlog.c
*** src/backend/access/transam/xlog.c	17 Apr 2005 03:04:29 -0000	1.187
--- src/backend/access/transam/xlog.c	18 Apr 2005 22:11:10 -0000
***************
*** 23,28 ****
--- 23,29 ----
  #include <sys/time.h>
  
  #include "access/clog.h"
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/xact.h"
  #include "access/xlog.h"
***************
*** 3534,3544 ****
--- 3535,3549 ----
  	checkPoint.ThisTimeLineID = ThisTimeLineID;
  	checkPoint.nextXid = FirstNormalTransactionId;
  	checkPoint.nextOid = FirstBootstrapObjectId;
+ 	checkPoint.nextMulti = FirstMultiXactId;
  	checkPoint.time = time(NULL);
  
  	ShmemVariableCache->nextXid = checkPoint.nextXid;
  	ShmemVariableCache->nextOid = checkPoint.nextOid;
  	ShmemVariableCache->oidCount = 0;
+ 	ShmemVariableCache->nextMXact = checkPoint.nextMulti;
+ 	ShmemVariableCache->nextMXoffset = 0;
+ 	ShmemVariableCache->mXactCount = 0;
  
  	/* Set up the XLOG page header */
  	page->xlp_magic = XLOG_PAGE_MAGIC;
***************
*** 3613,3618 ****
--- 3618,3624 ----
  	/* Bootstrap the commit log, too */
  	BootStrapCLOG();
  	BootStrapSUBTRANS();
+ 	BootStrapMultiXact();
  }
  
  static char *
***************
*** 4187,4194 ****
  					checkPoint.undo.xlogid, checkPoint.undo.xrecoff,
  					wasShutdown ? "TRUE" : "FALSE")));
  	ereport(LOG,
! 			(errmsg("next transaction ID: %u; next OID: %u",
! 					checkPoint.nextXid, checkPoint.nextOid)));
  	if (!TransactionIdIsNormal(checkPoint.nextXid))
  		ereport(PANIC,
  				(errmsg("invalid next transaction ID")));
--- 4193,4200 ----
  					checkPoint.undo.xlogid, checkPoint.undo.xrecoff,
  					wasShutdown ? "TRUE" : "FALSE")));
  	ereport(LOG,
! 			(errmsg("next transaction ID: %u; next OID: %u; next MultiXactId: %u",
! 					checkPoint.nextXid, checkPoint.nextOid, checkPoint.nextMulti)));
  	if (!TransactionIdIsNormal(checkPoint.nextXid))
  		ereport(PANIC,
  				(errmsg("invalid next transaction ID")));
***************
*** 4196,4201 ****
--- 4202,4210 ----
  	ShmemVariableCache->nextXid = checkPoint.nextXid;
  	ShmemVariableCache->nextOid = checkPoint.nextOid;
  	ShmemVariableCache->oidCount = 0;
+ 	ShmemVariableCache->nextMXact = checkPoint.nextMulti;
+ 	ShmemVariableCache->mXactCount = 0;
+ 	ShmemVariableCache->nextMXoffset = 0;
  
  	/*
  	 * We must replay WAL entries using the same TimeLineID they were
***************
*** 4549,4554 ****
--- 4558,4564 ----
  	/* Start up the commit log, too */
  	StartupCLOG();
  	StartupSUBTRANS();
+ 	StartupMultiXact();
  
  	ereport(LOG,
  			(errmsg("database system is ready")));
***************
*** 4737,4742 ****
--- 4747,4753 ----
  	CreateCheckPoint(true, true);
  	ShutdownCLOG();
  	ShutdownSUBTRANS();
+ 	ShutdownMultiXact();
  	CritSectionCount--;
  
  	ereport(LOG,
***************
*** 4919,4924 ****
--- 4930,4941 ----
  		checkPoint.nextOid += ShmemVariableCache->oidCount;
  	LWLockRelease(OidGenLock);
  
+ 	LWLockAcquire(MultiXactGenLock, LW_SHARED);
+ 	checkPoint.nextMulti = ShmemVariableCache->nextMXact;
+ 	if (!shutdown)
+ 		checkPoint.nextMulti += ShmemVariableCache->mXactCount;
+ 	LWLockRelease(MultiXactGenLock);
+ 
  	/*
  	 * Having constructed the checkpoint record, ensure all shmem disk
  	 * buffers and commit-log buffers are flushed to disk.
***************
*** 4935,4940 ****
--- 4952,4958 ----
  
  	CheckPointCLOG();
  	CheckPointSUBTRANS();
+ 	CheckPointMultiXact();
  	FlushBufferPool();
  
  	START_CRIT_SECTION();
***************
*** 5053,5058 ****
--- 5071,5088 ----
  	(void) XLogInsert(RM_XLOG_ID, XLOG_NEXTOID, &rdata);
  }
  
+ void
+ XLogPutNextMultiXactId(MultiXactId nextMulti)
+ {
+ 	XLogRecData rdata;
+ 
+ 	rdata.buffer = InvalidBuffer;
+ 	rdata.data = (char *) (&nextMulti);
+ 	rdata.len = sizeof(MultiXactId);
+ 	rdata.next = NULL;
+ 	(void) XLogInsert(RM_XLOG_ID, XLOG_NEXTMULTI, &rdata);
+ }
+ 
  /*
   * XLOG resource manager's routines
   */
***************
*** 5072,5077 ****
--- 5102,5119 ----
  			ShmemVariableCache->oidCount = 0;
  		}
  	}
+ 	else if (info == XLOG_NEXTMULTI)
+ 	{
+ 		MultiXactId	nextMulti;
+ 
+ 		memcpy(&nextMulti, XLogRecGetData(record), sizeof(MultiXactId));
+ 		if (ShmemVariableCache->nextMXact < nextMulti)
+ 		{
+ 			ShmemVariableCache->nextMXact = nextMulti;
+ 			ShmemVariableCache->mXactCount = 0;
+ 			ShmemVariableCache->nextMXoffset = 0;
+ 		}
+ 	}
  	else if (info == XLOG_CHECKPOINT_SHUTDOWN)
  	{
  		CheckPoint	checkPoint;
***************
*** 5081,5086 ****
--- 5123,5131 ----
  		ShmemVariableCache->nextXid = checkPoint.nextXid;
  		ShmemVariableCache->nextOid = checkPoint.nextOid;
  		ShmemVariableCache->oidCount = 0;
+ 		ShmemVariableCache->nextMXact = checkPoint.nextMulti;
+ 		ShmemVariableCache->mXactCount = 0;
+ 		ShmemVariableCache->nextMXoffset = 0;
  
  		/*
  		 * TLI may change in a shutdown checkpoint, but it shouldn't
***************
*** 5150,5155 ****
--- 5195,5207 ----
  		memcpy(&nextOid, rec, sizeof(Oid));
  		sprintf(buf + strlen(buf), "nextOid: %u", nextOid);
  	}
+ 	else if (info == XLOG_NEXTMULTI)
+ 	{
+ 		MultiXactId	multi;
+ 
+ 		memcpy(&multi, rec, sizeof(MultiXactId));
+ 		sprintf(buf + strlen(buf), "nextMultiXact: %u", multi);
+ 	}
  	else
  		strcat(buf, "UNKNOWN");
  }
Index: src/backend/commands/portalcmds.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/commands/portalcmds.c,v
retrieving revision 1.40
diff -c -r1.40 portalcmds.c
*** src/backend/commands/portalcmds.c	11 Apr 2005 15:59:34 -0000	1.40
--- src/backend/commands/portalcmds.c	18 Apr 2005 22:01:50 -0000
***************
*** 90,96 ****
  	if (query->rowMarks != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("DECLARE CURSOR ... FOR UPDATE is not supported"),
  				 errdetail("Cursors must be READ ONLY.")));
  
  	plan = planner(query, true, stmt->options, NULL);
--- 90,96 ----
  	if (query->rowMarks != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("DECLARE CURSOR ... FOR UPDATE/SHARE is not supported"),
  				 errdetail("Cursors must be READ ONLY.")));
  
  	plan = planner(query, true, stmt->options, NULL);
Index: src/backend/commands/trigger.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/commands/trigger.c,v
retrieving revision 1.186
diff -c -r1.186 trigger.c
*** src/backend/commands/trigger.c	14 Apr 2005 20:03:24 -0000	1.186
--- src/backend/commands/trigger.c	18 Apr 2005 22:20:48 -0000
***************
*** 1597,1603 ****
  		*newSlot = NULL;
  		tuple.t_self = *tid;
  ltrmark:;
! 		test = heap_mark4update(relation, &tuple, &buffer, cid);
  		switch (test)
  		{
  			case HeapTupleSelfUpdated:
--- 1597,1603 ----
  		*newSlot = NULL;
  		tuple.t_self = *tid;
  ltrmark:;
! 		test = heap_lock_tuple(relation, &tuple, &buffer, cid, LockTupleExclusive);
  		switch (test)
  		{
  			case HeapTupleSelfUpdated:
***************
*** 1634,1643 ****
  				 */
  				return NULL;
  
! 			default:
  				ReleaseBuffer(buffer);
! 				elog(ERROR, "unrecognized heap_mark4update status: %u",
! 					 test);
  				return NULL;	/* keep compiler quiet */
  		}
  	}
--- 1634,1643 ----
  				 */
  				return NULL;
  
! 			case HeapTupleBeingUpdated:
! 			case HeapTupleInvisible:
  				ReleaseBuffer(buffer);
! 				elog(ERROR, "invalid heap_locktuple status %d", test);
  				return NULL;	/* keep compiler quiet */
  		}
  	}
Index: src/backend/commands/vacuum.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/commands/vacuum.c,v
retrieving revision 1.306
diff -c -r1.306 vacuum.c
*** src/backend/commands/vacuum.c	14 Apr 2005 20:03:24 -0000	1.306
--- src/backend/commands/vacuum.c	18 Apr 2005 22:23:18 -0000
***************
*** 1800,1806 ****
  			 !TransactionIdPrecedes(HeapTupleHeaderGetXmin(tuple.t_data),
  									OldestXmin)) ||
  				(!(tuple.t_data->t_infomask & (HEAP_XMAX_INVALID |
! 											   HEAP_MARKED_FOR_UPDATE)) &&
  				 !(ItemPointerEquals(&(tuple.t_self),
  									 &(tuple.t_data->t_ctid)))))
  			{
--- 1800,1806 ----
  			 !TransactionIdPrecedes(HeapTupleHeaderGetXmin(tuple.t_data),
  									OldestXmin)) ||
  				(!(tuple.t_data->t_infomask & (HEAP_XMAX_INVALID |
! 				   							  HEAP_LOCKED)) &&
  				 !(ItemPointerEquals(&(tuple.t_self),
  									 &(tuple.t_data->t_ctid)))))
  			{
***************
*** 1839,1845 ****
  				 * we have to move to the end of chain.
  				 */
  				while (!(tp.t_data->t_infomask & (HEAP_XMAX_INVALID |
! 											  HEAP_MARKED_FOR_UPDATE)) &&
  					   !(ItemPointerEquals(&(tp.t_self),
  										   &(tp.t_data->t_ctid))))
  				{
--- 1839,1845 ----
  				 * we have to move to the end of chain.
  				 */
  				while (!(tp.t_data->t_infomask & (HEAP_XMAX_INVALID |
! 												  HEAP_LOCKED)) &&
  					   !(ItemPointerEquals(&(tp.t_self),
  										   &(tp.t_data->t_ctid))))
  				{
Index: src/backend/executor/execMain.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/executor/execMain.c,v
retrieving revision 1.246
diff -c -r1.246 execMain.c
*** src/backend/executor/execMain.c	14 Apr 2005 01:38:17 -0000	1.246
--- src/backend/executor/execMain.c	18 Apr 2005 22:24:43 -0000
***************
*** 567,572 ****
--- 567,574 ----
  	{
  		ListCell   *l;
  
+ 		estate->es_forUpdate = parseTree->forUpdate;
+ 
  		foreach(l, parseTree->rowMarks)
  		{
  			Index		rti = lfirst_int(l);
***************
*** 1126,1131 ****
--- 1128,1136 ----
  										 * ctid!! */
  				tupleid = &tuple_ctid;
  			}
+ 			/*
+ 			 * Process any FOR UPDATE or FOR SHARE locking requested.
+ 			 */
  			else if (estate->es_rowMark != NIL)
  			{
  				ListCell   *l;
***************
*** 1137,1142 ****
--- 1142,1148 ----
  					Buffer		buffer;
  					HeapTupleData tuple;
  					TupleTableSlot *newSlot;
+ 					LockTupleMode	lockmode;
  					HTSU_Result		test;
  
  					if (!ExecGetJunkAttribute(junkfilter,
***************
*** 1151,1159 ****
  					if (isNull)
  						elog(ERROR, "\"%s\" is NULL", erm->resname);
  
  					tuple.t_self = *((ItemPointer) DatumGetPointer(datum));
! 					test = heap_mark4update(erm->relation, &tuple, &buffer,
! 											estate->es_snapshot->curcid);
  					ReleaseBuffer(buffer);
  					switch (test)
  					{
--- 1157,1171 ----
  					if (isNull)
  						elog(ERROR, "\"%s\" is NULL", erm->resname);
  
+ 					if (estate->es_forUpdate)
+ 						lockmode = LockTupleExclusive;
+ 					else
+ 						lockmode = LockTupleShared;
+ 
  					tuple.t_self = *((ItemPointer) DatumGetPointer(datum));
! 					test = heap_lock_tuple(erm->relation, &tuple, &buffer,
! 										  estate->es_snapshot->curcid,
! 										  lockmode);
  					ReleaseBuffer(buffer);
  					switch (test)
  					{
***************
*** 1189,1195 ****
  							goto lnext;
  
  						default:
! 							elog(ERROR, "unrecognized heap_mark4update status: %u",
  								 test);
  							return (NULL);
  					}
--- 1201,1207 ----
  							goto lnext;
  
  						default:
! 							elog(ERROR, "unrecognized heap_locktuple status: %u",
  								 test);
  							return (NULL);
  					}
***************
*** 2088,2093 ****
--- 2100,2106 ----
  		epqstate->es_param_exec_vals = (ParamExecData *)
  			palloc0(estate->es_topPlan->nParamExec * sizeof(ParamExecData));
  	epqstate->es_rowMark = estate->es_rowMark;
+ 	epqstate->es_forUpdate = estate->es_forUpdate;
  	epqstate->es_instrument = estate->es_instrument;
  	epqstate->es_select_into = estate->es_select_into;
  	epqstate->es_into_oids = estate->es_into_oids;
Index: src/backend/executor/execUtils.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/executor/execUtils.c,v
retrieving revision 1.121
diff -c -r1.121 execUtils.c
*** src/backend/executor/execUtils.c	14 Apr 2005 20:03:24 -0000	1.121
--- src/backend/executor/execUtils.c	18 Apr 2005 22:01:52 -0000
***************
*** 198,203 ****
--- 198,204 ----
  	estate->es_processed = 0;
  	estate->es_lastoid = InvalidOid;
  	estate->es_rowMark = NIL;
+ 	estate->es_forUpdate = false;
  
  	estate->es_instrument = false;
  	estate->es_select_into = false;
Index: src/backend/nodes/copyfuncs.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/nodes/copyfuncs.c,v
retrieving revision 1.301
diff -c -r1.301 copyfuncs.c
*** src/backend/nodes/copyfuncs.c	7 Apr 2005 01:51:38 -0000	1.301
--- src/backend/nodes/copyfuncs.c	18 Apr 2005 22:01:52 -0000
***************
*** 1518,1523 ****
--- 1518,1524 ----
  	COPY_NODE_FIELD(rtable);
  	COPY_NODE_FIELD(jointree);
  	COPY_NODE_FIELD(rowMarks);
+ 	COPY_SCALAR_FIELD(forUpdate);
  	COPY_NODE_FIELD(targetList);
  	COPY_NODE_FIELD(groupClause);
  	COPY_NODE_FIELD(havingQual);
***************
*** 1598,1604 ****
  	COPY_NODE_FIELD(sortClause);
  	COPY_NODE_FIELD(limitOffset);
  	COPY_NODE_FIELD(limitCount);
! 	COPY_NODE_FIELD(forUpdate);
  	COPY_SCALAR_FIELD(op);
  	COPY_SCALAR_FIELD(all);
  	COPY_NODE_FIELD(larg);
--- 1599,1605 ----
  	COPY_NODE_FIELD(sortClause);
  	COPY_NODE_FIELD(limitOffset);
  	COPY_NODE_FIELD(limitCount);
! 	COPY_NODE_FIELD(lockingClause);
  	COPY_SCALAR_FIELD(op);
  	COPY_SCALAR_FIELD(all);
  	COPY_NODE_FIELD(larg);
Index: src/backend/nodes/equalfuncs.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/nodes/equalfuncs.c,v
retrieving revision 1.240
diff -c -r1.240 equalfuncs.c
*** src/backend/nodes/equalfuncs.c	7 Apr 2005 01:51:38 -0000	1.240
--- src/backend/nodes/equalfuncs.c	18 Apr 2005 22:01:53 -0000
***************
*** 642,647 ****
--- 642,648 ----
  	COMPARE_NODE_FIELD(rtable);
  	COMPARE_NODE_FIELD(jointree);
  	COMPARE_NODE_FIELD(rowMarks);
+ 	COMPARE_SCALAR_FIELD(forUpdate);
  	COMPARE_NODE_FIELD(targetList);
  	COMPARE_NODE_FIELD(groupClause);
  	COMPARE_NODE_FIELD(havingQual);
***************
*** 706,712 ****
  	COMPARE_NODE_FIELD(sortClause);
  	COMPARE_NODE_FIELD(limitOffset);
  	COMPARE_NODE_FIELD(limitCount);
! 	COMPARE_NODE_FIELD(forUpdate);
  	COMPARE_SCALAR_FIELD(op);
  	COMPARE_SCALAR_FIELD(all);
  	COMPARE_NODE_FIELD(larg);
--- 707,713 ----
  	COMPARE_NODE_FIELD(sortClause);
  	COMPARE_NODE_FIELD(limitOffset);
  	COMPARE_NODE_FIELD(limitCount);
! 	COMPARE_NODE_FIELD(lockingClause);
  	COMPARE_SCALAR_FIELD(op);
  	COMPARE_SCALAR_FIELD(all);
  	COMPARE_NODE_FIELD(larg);
Index: src/backend/nodes/outfuncs.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/nodes/outfuncs.c,v
retrieving revision 1.246
diff -c -r1.246 outfuncs.c
*** src/backend/nodes/outfuncs.c	6 Apr 2005 16:34:05 -0000	1.246
--- src/backend/nodes/outfuncs.c	18 Apr 2005 22:01:53 -0000
***************
*** 1192,1198 ****
  	WRITE_NODE_FIELD(sortClause);
  	WRITE_NODE_FIELD(limitOffset);
  	WRITE_NODE_FIELD(limitCount);
! 	WRITE_NODE_FIELD(forUpdate);
  	WRITE_ENUM_FIELD(op, SetOperation);
  	WRITE_BOOL_FIELD(all);
  	WRITE_NODE_FIELD(larg);
--- 1192,1198 ----
  	WRITE_NODE_FIELD(sortClause);
  	WRITE_NODE_FIELD(limitOffset);
  	WRITE_NODE_FIELD(limitCount);
! 	WRITE_NODE_FIELD(lockingClause);
  	WRITE_ENUM_FIELD(op, SetOperation);
  	WRITE_BOOL_FIELD(all);
  	WRITE_NODE_FIELD(larg);
***************
*** 1309,1314 ****
--- 1309,1315 ----
  	WRITE_NODE_FIELD(rtable);
  	WRITE_NODE_FIELD(jointree);
  	WRITE_NODE_FIELD(rowMarks);
+ 	WRITE_BOOL_FIELD(forUpdate);
  	WRITE_NODE_FIELD(targetList);
  	WRITE_NODE_FIELD(groupClause);
  	WRITE_NODE_FIELD(havingQual);
